--====================================================================================
-- All work by Pastry.
-- You have no permission to edit, redistribute or upload. That's all!
--====================================================================================
-- CaRP gas station UI
--====================================================================================
local M = {}
print("Loading Carp Gas Station UI...")

M.dependencies = {"ui_imgui", "carp_ui_base"}

local im = ui_imgui
local base = carp_ui_base

local lastPressed = 0

-- draw functions: -->
local function drawGasStationUI()
  if not base.beginWindow("GasStationUI", "Gas Station Menu", nil, true) then base.endWindow() return end

  im.SetWindowFontScale(base.getUISetting("window_scale"))


  im.TextWrapped("Welcome to [insert gas station name]!")
  base.drawBalance()

  im.Separator()

  im.Columns(2, "carpfuelstation")

  im.TextWrapped("Add 5 liters of:")
  im.NextColumn()
  if lastPressed < os.clock() - 0.5 then
    if im.Button("Gas, gas, gas!") then
      carp_vehicle.requestRefuel()

      lastPressed = os.clock()
    end

    if im.Button("N*trous please!") then
      carp_vehicle.requestNitrousRefuel()

      lastPressed = os.clock()
    end
  else
    im.TextDisabled("Gas, gas, gas!")
    im.TextDisabled("N*trous please!")
  end

  im.Columns(1)

  base.endWindow()
end

-- draw functions <--


local function onExtensionLoaded()
  base.registerWindow("GasStationUI", im.ImVec2(300, 450))

  print("Gas Station UI initialized.")
end

local function showGasStationUI(show)
  if show then
    base.showWindow("GasStationUI")
  else
    base.hideWindow("GasStationUI")
  end
end

local function onUpdate()
  drawGasStationUI()
end

M.onExtensionLoaded = onExtensionLoaded
M.showGasStationUI = showGasStationUI
M.onUpdate = onUpdate

print("Gas Station UI loaded")
return M
