--====================================================================================
-- All work by Pastry and deer.
-- You have no permission to edit, redistribute or upload. That's all!
--====================================================================================
-- CaRP UI
--====================================================================================
local M = {}
print("Loading Carp UI...")

M.dependencies = { "ui_imgui", "carp_ui_base" }

local im = ui_imgui
local base = carp_ui_base

local UI_MISSION_STREAK = nil


-- draw functions: -->


local function drawMissionStreak()
  if not UI_MISSION_STREAK or UI_MISSION_STREAK < 2 then
    return
  end

  im.TextWrapped("Mission Streak: " .. UI_MISSION_STREAK)
end

local function drawMissionInfo()
  im.Columns(2, "carpmissioninfo")

  if base.getMissionDescription() then
    im.TextWrapped("Mission:")

    if im.Button("Abandon Mission") then
      UI.chatSend("/abandon")
    end

    drawMissionStreak()

    im.NextColumn()

    im.TextWrapped(base.getMissionDescription())
    im.NextColumn()
  else
    im.TextWrapped("You currently do not have a mission!")
    drawMissionStreak()
    im.NextColumn()

    im.TextWrapped("When inside a mission contact press E or this button:")

    if im.Button("Start Mission") then
      UI.chatSend("/mission")
    end
    im.NextColumn()
  end
  im.Columns(1)
end

local function drawMainUI()
  if not base.beginWindow("CarpMainUI", "CaRP Main Menu", nil, true) then base.endWindow() return end

  im.SetWindowFontScale(base.getUISetting("window_scale"))

  base.drawBalance()

  im.Separator()

  drawMissionInfo()
  im.Separator()

  base.drawWindowOptions()
  im.Separator()

  base.drawShowHideMenu()

  base.endWindow()
end

-- draw functions <--

local function onClientReceiveMissionStreak(data)
  UI_MISSION_STREAK = tonumber(data)
end

local function onExtensionLoaded()
  if MPCoreNetwork then
    base.registerWindow("CarpMainUI", im.ImVec2(450, 300))

    base.registerDrawItem('missionInfo', 'Mission information', drawMissionInfo)

    base.showWindow("CarpMainUI")

    AddEventHandler("onClientReceiveMissionStreak", onClientReceiveMissionStreak)

    print("CarpUI initialized.")
  end
end

local function showWindow(show)
  if show then
    base.showWindow("CarpMainUI")
  else
    base.hideWindow("CarpMainUI")
  end
end

local function onUpdate()
  drawMainUI()
end

M.onExtensionLoaded = onExtensionLoaded
M.showWindow = showWindow
M.onUpdate = onUpdate

print("Carp UI loaded")
return M
