local M = {}

local eState = input.keys.E
local yState = input.keys.Y
local compRIm = 0
local compRITotalm = 0
local compRITotalmMission = 0
local bregenEnabled = false
local bregenCtdn = 0


local function comprierase()
  compRIm = 0
  compRITotalm = 0
end

local function compriMissionErase()
  compRITotalmMission = 0
end

local function sendCompRI()
  obj:queueGameEngineLua(
    "if carp and carp.updateCompRi then carp.updateCompRi(" ..
    obj:getID() .. ", " .. compRITotalm .. ", " .. compRITotalmMission .. ") end"
  )
end

local function sendDamage()
  local beamstats = obj:calcBeamStats()

  obj:queueGameEngineLua(
    "if carp_vehicle and carp_vehicle.setDamageStats then carp_vehicle.setDamageStats(" ..
    obj:getID() ..
    ", " .. beamstats.beams_broken .. ", " .. beamstats.beams_deformed .. ", " .. beamstats.beam_count .. ") end"
  )
end

local function sendFuel()
  local storages = energyStorage.getStorages()

  local fuelCapacity, fuelRemaining = 0, 0
  local nitrousCapacity, nitrousRemaining = 0, 0

  for k, v in pairs(storages) do
    if (k == "mainBottle") then
      nitrousCapacity = nitrousCapacity + v.capacity
      nitrousRemaining = nitrousRemaining + v.remainingMass
    elseif (k ~= "mainBottle") then
      fuelCapacity = fuelCapacity + v.capacity
      fuelRemaining = fuelRemaining + v.remainingVolume
    end
  end

  -- send gas and nitrous values
  obj:queueGameEngineLua(
    "if carp_vehicle and carp_vehicle.setFuelInfo then carp_vehicle.setFuelInfo(" ..
    obj:getID() ..
    ", " .. fuelCapacity .. ", " .. fuelRemaining .. ", " .. nitrousCapacity .. ", " .. nitrousRemaining .. ") end"
  )
end

local function updateVehiclePowerWeight()
  local maxPower = powertrain.getDevice("mainEngine").maxPower
  local weight = obj:calcBeamStats().total_weight

  obj:queueGameEngineLua("if carp then carp.updateVehiclePowerWeight(" .. maxPower .. ", " .. weight .. ") end")
end

local function onInit()
  compRITotalm = 0
  compRITotalmMission = 0
end

local function onReset()
  compRITotalm = 0
  sendCompRI()
end

local function getIsInAir()
  if not wheels or not wheels.wheels then
    return
  end

  local noContact = true
  for _, wheelItem in pairs(wheels.wheels) do
    if noContact == true then
      if wheelItem.contactMaterialID1 ~= -1 or wheelItem.contactMaterialID2 ~= -1 then
        noContact = false
      end
    end
  end

  -- if rotation is too excessive (vehicle is upside down)
  -- or velocity too low (under 30km/h), no airtime for you
  local rot = vec3(obj:getRotation())
  local velocityMs = obj:getVelocity():len()
  if math.abs(rot.x) > 0.5 or math.abs(rot.y) > 0.5 or velocityMs < 8.2 then
    noContact = false
  end

  obj:queueGameEngineLua(
    "if carp_ui_passenger and carp_passengers.setIsInAir then carp_passengers.setIsInAir(" ..
    obj:getID() .. ", " .. tostring(noContact) .. ") end"
  )
end

local function checkForAiMode()
  if ai and ai.mode ~= "disabled" then
    ai.setMode('disabled')
    print('caught a bad boy')
  end

end

local function updateGFX(dt)
  if not v.mpVehicleType == 'L' then return end

  checkForAiMode()

  -- send keypress updates
  if input.keys.E ~= eState then
    eState = input.keys.E
    obj:queueGameEngineLua("if carp then carp.ePress(" .. obj:getID() .. ", " .. tostring(eState) .. ") end")
  end

  if input.keys.Y ~= yState then
    yState = input.keys.Y
    obj:queueGameEngineLua("if carp and carp.yPress then carp.yPress(" .. tostring(yState) .. ") end")
  end

  -- calculate compRi
  compRIm = electrics.values.airspeed * dt
  compRITotalm = compRIm + compRITotalm
  compRITotalmMission = compRIm + compRITotalmMission

  --send stuff
  sendCompRI()
  sendDamage()

  if extensions.isExtensionLoaded("beamRegenerator") then
    if extensions.beamRegeneration.regenerate ~= beamstate.breakAllBreakgroups then
      extensions.beamRegeneration.regenerate = function()
        bregenEnabled = true
      end
    end
  end

  -- bregen handling
  if bregenEnabled then
    if not bregenCtdn then
      bregenCtdn = 0
    else
      if bregenCtdn > 0 and bregenCtdn < 0.2 then
        beamstate.breakAllBreakgroups()
        beamstate.breakHinges()
        beamstate.deflateTires()
        beamstate.deflateRandomTire()

        obj:setGravity(-520)
      end

      if bregenCtdn > 2 and bregenCtdn < 2.05 then
        local a = 0

        obj:setGravity(-520)

        while a < 1000 do
          obj:setGravity(-520)
          fire.igniteRandomNode()
          a = a + 1
        end

        a = 0
      end

      if bregenCtdn > 3 and bregenCtdn < 3.03 then
        obj:setGravity(-520)
        obj:queueLuaCommand("recovery.startRecovering(true)")
      end

      if bregenCtdn > 7 then
        bregenEnabled = false
        bregenCtdn = 0

        obj:queueGameEngineLua("MPCoreNetwork.leaveServer(true)")
      end

      bregenCtdn = bregenCtdn + dt
    end
  end

  -- update isInAir for excitementScore
  getIsInAir()
end

M.onInit = onInit
M.onReset = onReset
M.updateGFX = updateGFX
M.sendFuel = sendFuel
M.comprierase = comprierase
M.compriMissionErase = compriMissionErase
M.updateVehiclePowerWeight = updateVehiclePowerWeight

return M
