log('I', 'carpload', "starting load")

if extensions.isExtensionLoaded("carp") then
  log("E", "carpload", "carp already loaded, skipping")
  return
end

local function loadFromDirectory(directory)
  local filePaths = FS:findFiles(directory, "*.lua", -1, true, false)
  local prefixLen = #"/lua/ge/extensions/"

  for _, file in ipairs(filePaths) do
    if not file then break end
    if FS:fileExists(file) then
      local relativePath = file:sub(prefixLen+1, -5) -- remove prefix and extension
      local extName = extensions.luaPathToExtName(relativePath)
      if not extensions.isExtensionLoaded(extName) then
        queueExtensionToLoad(extName)
        log('I', 'carpload', "loaded module " .. extName .. " from " .. file)
      else
        log('W', 'carpload', tostring(extName) .. " already loaded")
      end
    end
  end
end


queueExtensionToLoad("carp")
  log('I', 'carpload', "loaded module carp")


loadFromDirectory("/lua/ge/extensions/carp")

log('I', 'carpload', "done load")
